'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fluxStandardAction = require('flux-standard-action');

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var typeOf = function typeOf(type) {
  return function (val) {
    return (typeof val === 'undefined' ? 'undefined' : _typeof(val)) === type;
  };
};
var isFunction = typeOf('function');

exports.default = function (runIO) {
  return function futureMiddleware(_ref) {
    var dispatch = _ref.dispatch;

    var isIO = function isIO(io) {
      return io && isFunction(io[runIO]);
    };

    return function (next) {
      return function (action) {
        if (!(0, _fluxStandardAction.isFSA)(action)) {
          return isIO(action) ? dispatch(action[runIO]()) : next(action);
        }

        return isIO(action.payload) ? dispatch(_extends({}, action, { payload: action.payload[runIO]() })) : next(action);
      };
    };
  };
};